unit MainForm;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.ComCtrls, Vcl.Controls, WEBLib.GoogleChart, WEBLib.WebCtrls, WEBLib.ExtCtrls, Vcl.StdCtrls,
  WEBLib.StdCtrls, WebLib.Cookies, Vcl.Grids, WEBLib.DBCtrls, WEBLib.REST, WebLib.JSON, Data.DB, WEBLib.DB, WEBLib.CDS, Vcl.Imaging.GIFImg,
  WEBLib.Buttons, WEBLib.JQCtrls;

type
  TformMain = class(TWebForm)
    WebPageControl: TWebPageControl;
    WebPageControlKaart: TWebTabSheet;
    WebPageControlOpnamen: TWebTabSheet;
    WebPageControlSyntaxa: TWebTabSheet;
    WebPageControlHabtypen: TWebTabSheet;
    WebPageControlDecades: TWebTabSheet;
    WebPageControlOver: TWebTabSheet;
    WebHTMLDiv: TWebHTMLDiv;
    WebGoogleChart: TWebGoogleChart;
    WebPanel1: TWebPanel;
    WebLabel1: TWebLabel;
    WebRadioGroupResolution: TWebRadioGroup;
    WebLabel2: TWebLabel;
    WebLabel3: TWebLabel;
    WebLabel4: TWebLabel;
    btnSelect: TWebButton;
    WebLabel5: TWebLabel;
    btnClearMap: TWebButton;
    WebSplitter1: TWebSplitter;
    WebDBGridPlot: TWebDBGrid;
    WebDBGridSyntaxa: TWebDBGrid;
    WebDBGridHabtypen: TWebDBGrid;
    WebHttpRequestCount: TWebHttpRequest;
    edtYearStart: TWebEdit;
    edtYearEnd: TWebEdit;
    WebHttpRequestChart: TWebHttpRequest;
    WebClientDataSetHabtypes: TWebClientDataSet;
    WebClientConnectionHabtypes: TWebClientConnection;
    WebDataSourceHabtypes: TWebDataSource;
    WebClientConnectionSyntaxa: TWebClientConnection;
    WebClientDataSetSyntaxa: TWebClientDataSet;
    WebDataSourceSyntaxa: TWebDataSource;
    WebClientConnectionPlots: TWebClientConnection;
    WebClientDataSetPlots: TWebClientDataSet;
    WebDataSourcePlots: TWebDataSource;
    WebClientConnectionPlot: TWebClientConnection;
    WebClientDataSetPlot: TWebClientDataSet;
    WebDataSourcePlot: TWebDataSource;
    WebHTMLContainerIntro: TWebHTMLContainer;
    WebHTMLContainerResponse: TWebHTMLContainer;
    WebPanel2: TWebPanel;
    WebPanel3: TWebPanel;
    WebButtonOpnamen: TWebButton;
    WebDBGridPlots: TWebDBGrid;
    procedure WebFormCreate(Sender: TObject);
    procedure WebPageControlChange(Sender: TObject);
    procedure WebFormShow(Sender: TObject);
    procedure btnClearMapClick(Sender: TObject);
    procedure btnSelectClick(Sender: TObject);
    procedure WebHttpRequestCountResponse(Sender: TObject; AResponse: string);
    procedure WebHttpRequestCountAbort(Sender: TObject);
    procedure WebHttpRequestChartResponse(Sender: TObject; AResponse: string);
    procedure WebDBGridHabtypenFixedCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure WebClientConnectionHabtypesAfterConnect(Sender: TObject);
    procedure WebClientConnectionSyntaxaAfterConnect(Sender: TObject);
    procedure WebDBGridSyntaxaFixedCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure WebClientConnectionPlotsAfterConnect(Sender: TObject);
    procedure WebDBGridPlotsGetCellData(Sender: TObject; ACol, ARow: Integer; AField: TField; var AValue: string);
    procedure WebDBGridPlotsFixedCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure WebDBGridPlotsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure WebDBGridPlotsClick(Sender: TObject);
    procedure WebClientConnectionPlotAfterConnect(Sender: TObject);
    procedure WebRadioGroupResolutionChange(Sender: TObject);
    procedure WebToggleButtonClick(Sender: TObject);
    procedure WebButtonOpnamenClick(Sender: TObject);
  private
    { Private declarations }
    FCount: Integer;
    FOSMLoaded: Boolean;
    procedure DoChart;
    procedure ShowChart(_response: String);
    procedure LoadOSM;
    procedure DoSelection;
    procedure DoHabitattypen;
    procedure DoSyntaxa;
    procedure DoPlots;
    procedure DoPlot(_plotObsID: String);
    procedure ClearSelection;
    procedure SaveToCSV(_webCLDS: TWebClientDataSet; _filename: String);
  public
    { Public declarations }
  end;

var
  formMain: TformMain;

implementation

{$R *.dfm}

procedure TformMain.WebButtonOpnamenClick(Sender: TObject);
begin
   if webclientdatasetPlots.RecordCount = 0 then
      Exit;
   SaveToCSV(WebClientDataSetPlots, 'LVD_Selectie_opnamen.csv');
//   WebDBGridPlots.SaveToCSV('LVD_Selectie_opnamen.csv', #9, True);
//   WebDBGridSyntaxa.SaveToCSV('LVD_Selectie_syntaxa.csv', #9, False);
//   WebDBGridHabtypen.SaveToCSV('LVD_Selectie_habtypen.csv', #9, False);
end;

procedure TformMain.WebClientConnectionHabtypesAfterConnect(Sender: TObject);
begin
   WebDbGridHabtypen.Columns[1].Width := 600;
end;

procedure TformMain.WebClientConnectionPlotAfterConnect(Sender: TObject);
begin
   WebDbGridPlot.Columns[0].Width := 200;
   WebDbGridPlot.Columns[1].Width := 150;
   WebDbGridPlot.Columns[2].Width := 40;
   WebDbGridPlot.Columns[3].Width := 80;
end;

procedure TformMain.WebClientConnectionPlotsAfterConnect(Sender: TObject);
begin
   WebDbGridPlots.Columns[1].Width := 200;
   WebDbGridPlots.Columns[3].Width := 400;
   WebDbGridPlots.Columns[4].Width := 200;
   WebDbGridPlots.Columns[5].Width := 100;
   // show the first plo
   WebDBGridPlotsClick(nil);
end;

procedure TformMain.WebClientConnectionSyntaxaAfterConnect(Sender: TObject);
begin
   WebDbGridSyntaxa.Columns[1].Width := 400;
end;

procedure TformMain.WebDBGridHabtypenFixedCellClick(Sender: TObject; ACol, ARow: Integer);
var
  LIndex: string;
  desc: boolean;
  opt: TIndexOptions;
  webDbGrid: TWebDbGrid;
begin
  if ACol = 0 then
    Exit;

  webDbGrid := TWebDbGrid(Sender);
  Lindex := 'By' + WebDBGrid.Columns[ACol - 1].DataField;

  // toggle sort order when the same column is clicked
  desc := SameText(webclientdatasetHabtypes.ActiveIndex, LIndex);

  if desc then
    LIndex := LIndex + 'Desc';

  opt := [];

  if desc then
    opt := opt + [ixDescending];

  // clear any previous indexes and add the new index to sort
  webclientdatasetHabtypes.Indexes.Clear;
  webclientdatasetHabtypes.Indexes.Add(LIndex, WebDBGrid.Columns[ACol - 1].DataField, opt);
  webclientdatasetHabtypes.ActiveIndex := LIndex;

  // set the sort indicator in the grid column header
  if ixDescending in webclientdatasetHabtypes.Indexes.Find(Lindex).Options then
    WebDBGrid.Columns[ACol - 1].SortIndicator := siDescending
  else
    WebDBGrid.Columns[ACol - 1].SortIndicator := siAscending;

  // force the grid to update
  WebDataSourceHabtypes.DataSet :=  WebClientDataSetHabtypes;
end;

procedure TformMain.WebDBGridPlotsClick(Sender: TObject);
begin
   DoPlot(WebClientDataSetPlots.FieldByName('PlotObsID').AsString);
end;

procedure TformMain.WebDBGridPlotsFixedCellClick(Sender: TObject; ACol, ARow: Integer);
var
  LIndex: string;
  desc: boolean;
  opt: TIndexOptions;
  webDbGrid: TWebDbGrid;
  webclientdataset: TWebClientDataSet;
  webdatasource: TWebDataSource;
begin
  if ACol = 0 then
    Exit;

  webDbGrid := TWebDbGrid(Sender);
  webdatasource := webDataSourcePlots;
  webclientdataset := webclientdatasetPlots;

  Lindex := 'By' + WebDBGrid.Columns[ACol - 1].DataField;

  // toggle sort order when the same column is clicked
  desc := SameText(webclientdataset.ActiveIndex, LIndex);

  if desc then
    LIndex := LIndex + 'Desc';

  opt := [];

  if desc then
    opt := opt + [ixDescending];

  // clear any previous indexes and add the new index to sort
  webclientdataset.Indexes.Clear;
  webclientdataset.Indexes.Add(LIndex, WebDBGrid.Columns[ACol - 1].DataField, opt);
  webclientdataset.ActiveIndex := LIndex;

  // set the sort indicator in the grid column header
  if ixDescending in webclientdataset.Indexes.Find(Lindex).Options then
    WebDBGrid.Columns[ACol - 1].SortIndicator := siDescending
  else
    WebDBGrid.Columns[ACol - 1].SortIndicator := siAscending;

  // force the grid to update
  WebDataSource.DataSet :=  WebClientDataSet;
  // force column width
  WebClientConnectionPlotsAfterConnect(nil);
end;

procedure TformMain.WebDBGridPlotsGetCellData(Sender: TObject; ACol, ARow: Integer; AField: TField; var AValue: string);
var
   resolution: Integer;
const
   c_resolutions: array[0..4] of string = ('Uurhok', 'Kilometerhok', 'Hectometerhok', 'Decameterhok', 'GPS-locatie');
begin
   if (ACol = 5) and (ARow > 0) and TryStrToInt(AValue, resolution) then
      AValue := c_resolutions[resolution - 1];
end;

procedure TformMain.WebDBGridPlotsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   DoPlot(WebClientDataSetPlots.FieldByName('PlotObsID').AsString);
end;

procedure TformMain.WebDBGridSyntaxaFixedCellClick(Sender: TObject; ACol, ARow: Integer);
var
  LIndex: string;
  desc: boolean;
  opt: TIndexOptions;
  webDbGrid: TWebDbGrid;
  webclientdataset: TWebClientDataSet;
  webdatasource: TWebDataSource;
begin
  if (ACol = 0) or (ARow = 0) then
    Exit;

  webDbGrid := TWebDbGrid(Sender);
  webdatasource := webDataSourceSyntaxa;
  webclientdataset := webclientdatasetSyntaxa;

  Lindex := 'By' + WebDBGrid.Columns[ACol - 1].DataField;

  // toggle sort order when the same column is clicked
  desc := SameText(webclientdataset.ActiveIndex, LIndex);

  if desc then
    LIndex := LIndex + 'Desc';

  opt := [];

  if desc then
    opt := opt + [ixDescending];

  // clear any previous indexes and add the new index to sort
  webclientdataset.Indexes.Clear;
  webclientdataset.Indexes.Add(LIndex, WebDBGrid.Columns[ACol - 1].DataField, opt);
  webclientdataset.ActiveIndex := LIndex;

  // set the sort indicator in the grid column header
  if ixDescending in webclientdataset.Indexes.Find(Lindex).Options then
    WebDBGrid.Columns[ACol - 1].SortIndicator := siDescending
  else
    WebDBGrid.Columns[ACol - 1].SortIndicator := siAscending;

  // force the grid to update
  WebDataSource.DataSet :=  WebClientDataSet;
end;

procedure TformMain.WebFormCreate(Sender: TObject);
begin
   FCount := 0;
   FOSMLoaded := False;
   WebPageControl.TabIndex := 0;
   WebHTMLContainerResponse.HTML.Clear;
end;

procedure TformMain.btnSelectClick(Sender: TObject);
begin
   DoSelection;
end;

procedure TformMain.ClearSelection;
begin
   FCount := 0;
   Application.RunScript('clearMap()');
   WebHTMLContainerResponse.HTML.Clear;
   // WebToggleButton.Checked := False;
   WebToggleButtonClick(nil);
end;

procedure TformMain.DoSelection;
var
   url, wkt: String;
   cookies: TCookies;
   cookie: TCookie;
   yearStart, yearEnd: Integer;
   resolution: Byte;
begin
   FCount := 0;
   cookies := TCookies.Create;
   cookies.GetCookies;
   if cookies.Count = 0 then
      // MessageDlg('Markeer een gebied op de kaart', mtWarning, [])
      ShowMessage('Markeer een gebied op de kaart')
   else
   begin
      cookie := Cookies.Items[0];
      wkt := cookie.Value;
      if TryStrToInt(edtYearStart.Text, yearStart) and TryStrToInt(edtYearEnd.Text, yearEnd) then
      begin
         resolution := 5 - WebRadioGroupResolution.ItemIndex;
         url := Format('lvddata.aspx?jaarmin=%u&jaarmax=%u&wkt=%s&resolutie=%u', [yearStart, yearEnd, wkt, resolution]);
         WebHttpRequestCount.URL := url;
         WebHttpRequestCount.Execute;
      end else
         ShowMessage('Een of twee jaartallen zijn niet correct ingevoerd!');
   end;
 end;

procedure TformMain.LoadOSM;
begin
   if not FOSMLoaded then
   begin
      FOSMLoaded := True;
      Application.RunScript('doLoad(52.166351, 5.419006, 7)');
   end;
end;

procedure TformMain.ShowChart(_response: String);
var
   js: TJSON;
   ja: TJSONArray;
   jo: TJSONObject;
   i: Integer;
   aantal, decade, label_: String;
   decades: TStringList;
   count, iDecade: Integer;
begin
   WebGoogleChart.BeginUpdate;
   WebGoogleChart.Series.Clear;
   WebGoogleChart.EndUpdate;

   if (FCount <= 0) then
      Exit;

   decades := TStringList.Create;
   decades.Sorted := True;
   js := TJSON.Create;
   ja := TJSONArray(js.Parse(_response));
   for i := 0 to ja.Count - 1 do
   begin
      jo := TJSONObject(ja.Items[i]);
      decade := jo.GetJSONValue('decade');
      aantal := jo.GetJSONValue('aantal');
      if Length(decade) = 1 then
         decade := '0' + decade;
      decades.Add(decade + '=' + aantal);
   end;

   WebGoogleChart.BeginUpdate;
   WebGoogleChart.Title := 'Verdeling over decades';
   // WebGoogleChart.Series.Clear;
   with WebGoogleChart.Series.Add do
   begin
      Color := clRed;
      ChartType := gctBar;
      Title := '';
      for i := 0 to decades.Count - 1 do
      begin
         decade := decades.Names[i];
         iDecade := StrToInt(decade);
         iDecade := iDecade * 10 + 1900;
         label_ := IntToStr(iDecade) + '-' + IntToStr(iDecade + 10);
         count := StrToInt(decades.Values[decade]);
         Values.AddSinglePoint(count, label_);
      end;
   end;
   WebGoogleChart.EndUpdate;
end;

procedure TformMain.DoChart;
begin
   {$IFDEF DEBUG}
      WebHttpRequestChart.URL := 'decades.json';
   {$ELSE}
      WebHttpRequestChart.URL := 'lvddata.aspx?meta=perioden';
   {$ENDIF}
   WebHttpRequestChart.Execute;
end;

procedure TformMain.DoHabitattypen;
var
   url: String;
begin
   WebClientConnectionHabtypes.Active := False;
   if (FCount = 0) then
      Exit;
   {$IFDEF DEBUG}
      url := 'predictors.json';
   {$ELSE}
      url := 'lvddata.aspx?meta=habitattypen';
   {$ENDIF}
   WebClientConnectionHabtypes.Uri := url;
   WebClientConnectionHabtypes.Active := True;
   WebDbGridHabtypen.Setfocus;
end;

procedure TformMain.DoPlot(_plotObsID: String);
var
   url: String;
begin
   WebClientConnectionPlot.Active := False;
   if (FCount = 0) then
      Exit;
   url := 'lvddata.aspx?meta=vegetatieopname&plotobsid=' + _plotobsid;
   WebClientConnectionPlot.Uri := url;
   WebClientConnectionPlot.Active := True;
end;

procedure TformMain.DoPlots;
var
   url: String;
begin
   WebClientConnectionPlots.Active := False;
   if (FCount = 0) then
      Exit;
   url := 'lvddata.aspx?meta=vegetatieopnamen';
   WebClientConnectionPlots.Uri := url;
   WebClientConnectionPlots.Active := True;
   WebDbGridPlots.Setfocus;
end;

procedure TformMain.DoSyntaxa;
var
   url: String;
begin
   WebClientConnectionSyntaxa.Active := False;
   if (FCount = 0) then
      Exit;
   url := 'lvddata.aspx?meta=plantengemeenschappen';
   WebClientConnectionSyntaxa.Uri := url;
   WebClientConnectionSyntaxa.Active := True;
   WebDbGridSyntaxa.Setfocus;
end;

procedure TformMain.btnClearMapClick(Sender: TObject);
begin
   ClearSelection;
end;

procedure TformMain.WebFormShow(Sender: TObject);
begin
   WebDbGridPlots.ColWidths[0] := 16;
   WebDbGridPlot.ColWidths[0] := 16;
   WebDbGridSyntaxa.ColWidths[0] := 16;
   WebDbGridHabTypen.ColWidths[0] := 16;
   WebPageControl.TabIndex := 1;
//   WebPageControl.TabIndex := 0;
   WebPageControlChange(nil);
end;

procedure TformMain.WebHttpRequestChartResponse(Sender: TObject;
  AResponse: string);
begin
   ShowChart(AResponse);
end;

procedure TformMain.WebHttpRequestCountAbort(Sender: TObject);
begin
   ShowMessage('Abort')
end;

procedure TformMain.WebHttpRequestCountResponse(Sender: TObject; AResponse: string);
var
   p: Byte;
begin
   p := Pos('^', AResponse);
   FCount :=  StrToInt(Copy(AResponse, 1, p - 1));
   WebHTMLContainerResponse.HTML.Clear;
   WebHTMLContainerResponse.HTML.Add(Copy(AResponse, p + 1));
end;

procedure TformMain.WebPageControlChange(Sender: TObject);
begin
   case WebPageControl.TabIndex of
      1: LoadOSM;
      2: DoPlots;
      3: DoSyntaxa;
      4: DoHabitattypen;
      5: DoChart;
   end; 
end;


procedure TformMain.WebRadioGroupResolutionChange(Sender: TObject);
begin
   WebHTMLContainerResponse.HTML.Clear;
   FCount := 0;
end;

procedure TformMain.WebToggleButtonClick(Sender: TObject);
begin
//   if WebToggleButton.Checked then
//      Application.RunScript('polygon.activate()')
//   else
//      Application.RunScript('polygon.deactivate()');

end;

procedure TformMain.SaveToCSV(_webCLDS: TWebClientDataSet; _filename: String);
var   
   sl: TStringList;
   line: String;
   i: Word;
begin
  sl := TStringList.Create;
  try
   // header
   line := '';
   for i := 0 to _webCLDS.FieldDefs.Count - 1 do
      line := line + _webCLDS.FieldDefs[i].DisplayName + #9;  
   sl.Add(line);
   // data

   {
   WebDataSourcePlots.DataSet.First;
   while not WebDataSourcePlots.DataSet.EOF do
   begin
     for i := 0 to WebDataSourcePlots.DataSet.FieldCount - 1 do
         line := line + WebDataSourcePlots.DataSet.Fields[i].AsString + #9;
     sl.Add(line);    
     WebDataSourcePlots.DataSet.Next;
   end; 
   }

   // WebDBGridPlots.DataSource := nil;   
   WebDataSourcePlots.DataSet := Nil;
   _webCLDS.First;
   while not _webCLDS.EOF do
   begin
     line := ''; 
     for i := 0 to _webCLDS.FieldDefs.Count - 1 do
         line := line + _webCLDS.Fields[i].AsString + #9;
      line := StringReplace(line, '<em>', '', [rfReplaceAll]);   
      line := StringReplace(line, '</em>', '', [rfReplaceAll]);   
      sl.Add(line);
     _webCLDS.Next;
   end;  
    _webCLDS.First;
   
   sl.SaveToFile(_filename)
  finally
    FreeAndNil(sl);
     WebDataSourcePlots.Dataset := WebClientDataSetPlots;
      // WebDBGridPlots.DataSource := WebDataSourcePlots;   

  end;
end;

end.
                               